/*********** Siberian Winter - Version 1.0 ************/
/***** by M0nTy_PyTh0n - Founder of Hyena Studios *****/
/******* http://www.geocities.com/hyenastudios ********/

void fnSetTriggerParam(int prio=4, bool acti=false, bool runi=false, bool loopi=false) {
    rmSetTriggerPriority(prio);
    if (acti == true) rmSetTriggerActive(true);
    else rmSetTriggerActive(false);
    if (runi == true) rmSetTriggerRunImmediately(true);
    else rmSetTriggerRunImmediately(false);
    if (loopi == true) rmSetTriggerLoop(true);
    else rmSetTriggerLoop(false);
}

void main(void) {

    rmSetStatusText("",0.01);

    int myTiles = 9000;

    if(cMapSize == 1) {
        myTiles = 12000;
        rmEchoInfo("Large map");
    }

    int mySize = 2.0*sqrt(cNumberNonGaiaPlayers * myTiles);
    rmEchoInfo("Map size="+mySize+"m x "+mySize+"m");

    rmSetMapSize(mySize,mySize);
    rmSetSeaLevel(0);

    rmSetStatusText("",0.04);

    int i=0;
    int j=0;
    int k=0;
    int numTries=0;
    int failCount=0;
    int count=0;
    int myArmyDummy=0;
    float myRandomFloat=0.0;
    string LandTerrain = "SnowGrass25";
    string LandTerrainA = "SnowA";
    string LandTerrainB = "SnowGrass25";
    string LandTerrainC = "SnowSand25";
    string LandTerrainD = "SnowSand50";
    string LandTerrainE = "SnowGrass50";
    string CliffTerrain = "CliffNorseA";
    string CliffType = "Norse";
    string CityTerrain = "NorseRoadA";
    string ForestTree = "Pine Snow";
    string ForestType = "Snow Pine Forest";
    string LandRocks = "Rock River Icy";
    string LakeWater = "Norse River";
    string Sky = "SkyWinter";
    string myDummyString = "";

    rmSetSeaType("Norse River");
    rmTerrainInitialize(LandTerrain,4);
    rmSetLightingSet("Olympus");

//  Classes
    // Define some classes.

    int playerClass = rmDefineClass("Player Class");
    int patchClass = rmDefineClass("Patch Class");
    int cliffClass = rmDefineClass("Cliff Class");
    int beautyClass = rmDefineClass("Beauty Class");
    int forestClass = rmDefineClass("Forest Class");
    int huntableClass = rmDefineClass("bonus huntable");

// Constraints
    int avoidPlayerClass = rmCreateClassDistanceConstraint("Avoid Player Class Distance Constraint",playerClass,28.0);
    int avoidFarPlayerClass = rmCreateClassDistanceConstraint("Avoid Far Player Class Distance Constraint",playerClass,50.0);
    int avoidShortPlayerClass = rmCreateClassDistanceConstraint("Avoid Short Player Class Distance Constraint",playerClass,4.0);
    int avoidCliffClass = rmCreateClassDistanceConstraint("Avoid Cliff Class Distance Constraint",cliffClass,26.0);
    int avoidShortCliffClass = rmCreateClassDistanceConstraint("Avoid Short Cliff Class Distance Constraint",cliffClass,8.0);
    int avoidPatchClass = rmCreateClassDistanceConstraint("Avoid Patch Class Distance Constraint",patchClass,10.0);
    int avoidShortPatchClass = rmCreateClassDistanceConstraint("Avoid Short Patch Class Distance Constraint",patchClass,6.0);
    int avoidBeautyClass = rmCreateClassDistanceConstraint("Avoid Beauty Class Distance Constraint",beautyClass,25.0);
    int avoidShortSettlement = rmCreateTypeDistanceConstraint("avoid short settlement constraint","settlement",6.0);
    int avoidAllConstraint = rmCreateTypeDistanceConstraint("avoid all constraint","all",24.0);
    int avoidAllShortConstraint = rmCreateTypeDistanceConstraint("avoid all short constraint","all",4.0);
    int avoidTower = rmCreateTypeDistanceConstraint("towers avoid towers", "tower", 20.0);
    int avoidTower2 = rmCreateTypeDistanceConstraint("objects avoid towers", "tower", 22.0);
    int avoidForestObjConstraint = rmCreateTypeDistanceConstraint("forest obj", "all", 3.0);
    int avoidForestClass = rmCreateClassDistanceConstraint("forest v forest", forestClass, 26.0);
    int avoidForestSettleConstraint = rmCreateClassDistanceConstraint("forest settle", playerClass, 20.0);
    int avoidGold = rmCreateTypeDistanceConstraint("avoid gold", "gold", 30.0);
    int avoidShortGold = rmCreateTypeDistanceConstraint("gold vs. gold", "gold", 24.0);
    int avoidHerdable = rmCreateTypeDistanceConstraint("avoid herdable", "herdable", 20.0);
    int avoidFood = rmCreateTypeDistanceConstraint("avoid food", "food", 12.0);
    int avoidChickens = rmCreateTypeDistanceConstraint("avoid chickens", "chicken", 10.0);
    int avoidPredator = rmCreateTypeDistanceConstraint("avoid predator", "animalPredator", 40.0);
    int avoidBonusHuntable = rmCreateClassDistanceConstraint("avoid bonus huntable", huntableClass, 40.0);
    int avoidHuntable = rmCreateTypeDistanceConstraint("avoid huntable", "huntable", 20.0);
    int avoidRelic = rmCreateTypeDistanceConstraint("relic vs relic", "relic", 60.0);
    int avoidRock = rmCreateTypeDistanceConstraint("avoid rocks", "rock limestone sprite", 20.0);
    int avoidEdgeConstraint = rmCreateBoxConstraint("avoid edge constraint",rmXTilesToFraction(5),rmZTilesToFraction(5),
                                                                1.0 - rmXTilesToFraction(5),1.0 - rmZTilesToFraction(5));
    int avoidImpassableLand = rmCreateTerrainDistanceConstraint("avoid impassable land constraint","land",false,3.0);
    int avoidBuildings=rmCreateTypeDistanceConstraint("avoid buildings", "Building", 20.0);
    int avoidLandConstraint = rmCreateTerrainDistanceConstraint("avoid land constraint","land",true,3.0);

    // Cheesy "circular" placement of players.
    rmSetTeamSpacingModifier(0.75);
    rmPlacePlayersCircular(0.34, 0.42, rmDegreesToRadians(5.0));

    // Terrain Beautification
    failCount = 0;
    for(j=0; <cNumberPlayers*40){ 
        int id2 = rmCreateArea("patch beauty"+j);
        rmSetAreaSize(id2,rmAreaTilesToFraction(rmRandInt(60,300)),rmAreaTilesToFraction(rmRandInt(60,300)));
        rmSetAreaTerrainType(id2,LandTerrain);
        rmAddAreaTerrainLayer(id2,LandTerrainA, 0, 2);
        rmAddAreaTerrainLayer(id2,LandTerrainB, 2, 4);
        rmAddAreaTerrainLayer(id2,LandTerrainC, 4, 6);
        rmAddAreaTerrainLayer(id2,LandTerrainD, 6, 8);
        rmAddAreaTerrainLayer(id2,LandTerrainE, 8, 10);
        rmSetAreaMinBlobs(id2,1);
        rmSetAreaMaxBlobs(id2,1);
        rmSetAreaBaseHeight(id2,rmRandInt(3,5));
        rmSetAreaHeightBlend(id2,rmRandInt(1,2));    
        rmAddAreaToClass(id2,beautyClass);
        rmAddAreaConstraint(id2,avoidBeautyClass);
        rmAddAreaConstraint(id2, avoidImpassableLand);
        rmAddAreaConstraint(id2, avoidBuildings);
        rmSetAreaMinBlobDistance(id2, 0.0);
        rmSetAreaMaxBlobDistance(id2, 0.0);
        rmSetAreaCoherence(id2, 0.1);
        rmSetAreaWarnFailure(id2,false);
        if(rmBuildArea(id2)==false){
        // Stop trying once we fail 3 times in a row.
                failCount++;
                if(failCount==3)
                break;
            }
            else
            failCount=0;
        } 

// Players

   if(cNumberNonGaiaPlayers < 8)
      rmSetTeamSpacingModifier(0.25);
   else if(cNumberNonGaiaPlayers < 11) 
      rmSetTeamSpacingModifier(0.40);
   else
      rmSetTeamSpacingModifier(0.50);

   float playerFraction=rmAreaTilesToFraction(3600);
   for(i=1; <cNumberPlayers)
   {
      int id=rmCreateArea("Player"+i);
      rmSetPlayerArea(i, id);
      rmSetAreaSize(id, 0.9*playerFraction, 1.1*playerFraction);
      rmAddAreaToClass(id, playerClass);
      rmSetAreaWarnFailure(id, false);
      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 5);
      rmSetAreaMinBlobDistance(id, 16.0);
      rmSetAreaMaxBlobDistance(id, 40.0);
      rmSetAreaCoherence(id, 0.0);
      rmAddAreaConstraint(id, avoidPlayerClass);
      rmSetAreaLocPlayer(id, i);
      rmSetAreaTerrainType(id, "GrassDirt25");
      rmAddAreaTerrainLayer(id, "GrassDirt50", 8, 20);
      rmAddAreaTerrainLayer(id, "GrassDirt75", 0, 8);
   }

    rmSetStatusText("",0.07);

// Areas

    rmSetStatusText("",0.10);
   
   // Cliffage

   numTries=16*cNumberNonGaiaPlayers;
   failCount=0;
   for(i=0; <numTries)
   {
      int cliffID=rmCreateArea("cliff"+i);
      rmSetAreaWarnFailure(cliffID, false);
      rmSetAreaSize(cliffID, rmAreaTilesToFraction(400), rmAreaTilesToFraction(800));
      rmSetAreaCliffType(cliffID, CliffType);
      rmAddAreaToClass(cliffID, cliffClass);
      rmAddAreaConstraint(cliffID, avoidCliffClass);
      rmAddAreaConstraint(cliffID, avoidPlayerClass);
      rmAddAreaConstraint(cliffID, avoidBuildings);
      rmAddAreaConstraint(cliffID, avoidPatchClass);
      rmSetAreaMinBlobs(cliffID, 1);
      rmSetAreaMaxBlobs(cliffID, 1);
      rmSetAreaCliffEdge(cliffID, 3, 0.28, 0.0, 1.0, 0);
      rmSetAreaCliffPainting(cliffID, true, true, true, 1.5, true);
      rmSetAreaMinBlobDistance(cliffID, 16.0);
      rmSetAreaMaxBlobDistance(cliffID, 40.0);
      rmSetAreaCoherence(cliffID, 0.45);
      rmSetAreaSmoothDistance(cliffID, 5);
      rmSetAreaCliffHeight(cliffID, 7, 1.0, 1.0);
      rmSetAreaHeightBlend(cliffID, 2);
       
      if(rmBuildArea(cliffID)==false) {
         failCount++;
         if(failCount==3)
            break;
      }
      else failCount=0;

      int cliffMiddleID=rmCreateArea("cliffMiddle"+i,cliffID);
      rmSetAreaWarnFailure(cliffMiddleID, false);
      rmSetAreaSize(cliffMiddleID, rmAreaTilesToFraction(200), rmAreaTilesToFraction(300));
      rmSetAreaCliffType(cliffMiddleID, CliffType);
      rmAddAreaConstraint(cliffMiddleID, avoidBuildings);
      rmAddAreaConstraint(cliffMiddleID, avoidPatchClass);
      rmSetAreaMinBlobs(cliffMiddleID, 1);
      rmSetAreaMaxBlobs(cliffMiddleID, 1);
      rmSetAreaCliffEdge(cliffMiddleID, 3, 0.28, 0.0, 1.0, 0);
      rmSetAreaCliffPainting(cliffMiddleID, true, true, true, 1.5, true);
      rmSetAreaMinBlobDistance(cliffMiddleID, 16.0);
      rmSetAreaMaxBlobDistance(cliffMiddleID, 40.0);
      rmSetAreaCoherence(cliffMiddleID, 0.25);
      rmSetAreaSmoothDistance(cliffMiddleID, 5);
      rmSetAreaCliffHeight(cliffMiddleID, 7, 1.0, 1.0);
      rmSetAreaHeightBlend(cliffMiddleID, 2);
      rmBuildArea(cliffMiddleID);

      int cliffTopID=rmCreateArea("cliffTop"+i,cliffID);
      rmSetAreaWarnFailure(cliffTopID, false);
      rmSetAreaSize(cliffTopID, rmAreaTilesToFraction(80), rmAreaTilesToFraction(160));
      rmSetAreaCliffType(cliffTopID, CliffType);
      rmAddAreaConstraint(cliffTopID, avoidBuildings);
      rmAddAreaConstraint(cliffTopID, avoidPatchClass);
      rmSetAreaMinBlobs(cliffTopID, 1);
      rmSetAreaMaxBlobs(cliffTopID, 1);
      rmSetAreaCliffEdge(cliffTopID, 3, 0.25, 0.0, 1.0, 0);
      rmSetAreaCliffPainting(cliffTopID, true, true, true, 1.5, true);
      rmSetAreaMinBlobDistance(cliffTopID, 16.0);
      rmSetAreaMaxBlobDistance(cliffTopID, 40.0);
      rmSetAreaCoherence(cliffTopID, 0.25);
      rmSetAreaSmoothDistance(cliffTopID, 5);
      rmSetAreaCliffHeight(cliffTopID, 4, 1.0, 1.0);
      rmSetAreaHeightBlend(cliffTopID, 2);
      rmBuildArea(cliffTopID);
   }

    rmSetStatusText("",0.13);

// Objects

    // Starting settlements.
    int startingSettlementID=rmCreateObjectDef("Starting settlement");
    rmAddObjectDefItem(startingSettlementID, "Settlement Level 1", 1, 0.0);
    rmPlaceObjectDefPerPlayer(startingSettlementID,true,1);
    
    rmSetStatusText("",0.16);

    // Settlements.
    id=rmAddFairLoc("Settlement", false, true,  40, 80, 60, 10);

    id=rmAddFairLoc("Settlement", true, false, 60, 100, 60, 10);

    id=rmAddFairLoc("Settlement", false, false, 70, 120, 60, 10);

    if(rmPlaceFairLocs())
    {
        id=rmCreateObjectDef("far settlement2");
        rmAddObjectDefItem(id, "Settlement", 1, 0.0);
        for(i=1; <cNumberPlayers)
        {
        for(j=0; <rmGetNumberFairLocs(i))
            rmPlaceObjectDefAtLoc(id, i, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j), 1);
        }
    }

    rmSetStatusText("",0.19);

    // Starting towers.
    int startingTowerID=rmCreateObjectDef("Starting tower");
    rmAddObjectDefItem(startingTowerID, "tower", 1, 0.0);
    rmSetObjectDefMinDistance(startingTowerID, 22.0);
    rmSetObjectDefMaxDistance(startingTowerID, 28.0);
    rmAddObjectDefConstraint(startingTowerID, avoidTower);
    rmPlaceObjectDefPerPlayer(startingTowerID, true, 4);

    rmSetStatusText("",0.22);

    // Straggler trees.
    int stragglerTreeID=rmCreateObjectDef("straggler tree");
    rmAddObjectDefItem(stragglerTreeID, ForestTree, 1, 0.0);
    rmSetObjectDefMinDistance(stragglerTreeID, 12.0);
    rmSetObjectDefMaxDistance(stragglerTreeID, 15.0);
    rmPlaceObjectDefPerPlayer(stragglerTreeID, false, rmRandInt(2, 5));

    rmSetStatusText("",0.25);

    // Farms
    int startingFarmID=rmCreateObjectDef("Starting farm");
    rmAddObjectDefItem(startingFarmID, "Farm", 1, 0.0);
    rmSetObjectDefMinDistance(startingFarmID, 0.0);
    rmSetObjectDefMaxDistance(startingFarmID, 9.0);
    rmPlaceObjectDefPerPlayer(startingFarmID, true, 7);

    // Gold
    int startingGoldID=rmCreateObjectDef("Starting gold");
    rmAddObjectDefItem(startingGoldID, "Gold mine small", 1, 0.0);
    rmSetObjectDefMinDistance(startingGoldID, 20.0);
    rmSetObjectDefMaxDistance(startingGoldID, 25.0);
    rmAddObjectDefConstraint(startingGoldID, avoidGold);
    rmAddObjectDefConstraint(startingGoldID, avoidShortCliffClass);
    rmPlaceObjectDefPerPlayer(startingGoldID, false);

    rmSetStatusText("",0.28);

    // cows
    int closeCowsID=rmCreateObjectDef("close Cows");
    rmAddObjectDefItem(closeCowsID, "cow", rmRandInt(2,4), 2.0);
    rmSetObjectDefMinDistance(closeCowsID, 20.0);
    rmSetObjectDefMaxDistance(closeCowsID, 25.0);
    rmAddObjectDefConstraint(closeCowsID, avoidShortCliffClass);
    rmAddObjectDefConstraint(closeCowsID, avoidFood);
    rmPlaceObjectDefPerPlayer(closeCowsID, true);
    
    rmSetStatusText("",0.31);

    // chickens and berries
    int BerryNum=rmRandInt(6, 10);
    int closeBerriesID=rmCreateObjectDef("close berries");
    rmAddObjectDefItem(closeBerriesID, "berry bush", BerryNum, 4.0);
    rmSetObjectDefMinDistance(closeBerriesID, 30.0);
    rmSetObjectDefMaxDistance(closeBerriesID, 35.0);
    rmAddObjectDefConstraint(closeBerriesID, avoidShortCliffClass);
    rmAddObjectDefConstraint(closeBerriesID, avoidChickens);
    rmPlaceObjectDefPerPlayer(closeBerriesID, false);

    rmSetStatusText("",0.34);

    int closeChickensID=rmCreateObjectDef("close Chickens");
    rmAddObjectDefItem(closeChickensID, "chicken", BerryNum, 5.0);
    rmSetObjectDefMinDistance(closeChickensID, 25.0);
    rmSetObjectDefMaxDistance(closeChickensID, 30.0);
    rmAddObjectDefConstraint(closeChickensID, avoidShortCliffClass);
    rmPlaceObjectDefPerPlayer(closeChickensID, false);

    rmSetStatusText("",0.37);

    // Elk
    int closeElkID=rmCreateObjectDef("close elk");
    if(rmRandFloat(0,1)<0.75)
        rmAddObjectDefItem(closeElkID, "elk", rmRandInt(3,5), 4.0);
    else
        rmAddObjectDefItem(closeElkID, "elk", 2, 2.0);
    rmSetObjectDefMinDistance(closeElkID, 30.0);
    rmSetObjectDefMaxDistance(closeElkID, 50.0);
    rmAddObjectDefConstraint(closeElkID, avoidShortSettlement);
    rmAddObjectDefConstraint(closeElkID, avoidChickens);
    if(rmRandFloat(0,1)<0.9)
        rmPlaceObjectDefPerPlayer(closeElkID, false);
    else
        rmPlaceObjectDefPerPlayer(closeElkID, false, rmRandInt(3,6));

    rmSetStatusText("",0.40);

    // Medium things....
    // Gold
    int mediumGoldID=rmCreateObjectDef("medium gold");
    rmAddObjectDefItem(mediumGoldID, "Gold mine", 1, 0.0);
    rmSetObjectDefMinDistance(mediumGoldID, 40.0);
    rmSetObjectDefMaxDistance(mediumGoldID, 60.0);
    rmAddObjectDefConstraint(mediumGoldID, avoidShortGold);
    rmAddObjectDefConstraint(mediumGoldID, avoidShortSettlement);
    rmAddObjectDefConstraint(mediumGoldID, avoidFarPlayerClass);
    rmPlaceObjectDefPerPlayer(mediumGoldID, false, rmRandInt(1, 2));

    rmSetStatusText("",0.43);

    // Herds.
    int mediumCowID=rmCreateObjectDef("medium Cow");
    rmAddObjectDefItem(mediumCowID, "cow", rmRandFloat(1,2), 4.0);
    rmSetObjectDefMinDistance(mediumCowID, 50.0);
    rmSetObjectDefMaxDistance(mediumCowID, 100.0);
    rmAddObjectDefConstraint(mediumCowID, avoidFarPlayerClass);
    rmPlaceObjectDefPerPlayer(mediumCowID, false); 

    rmSetStatusText("",0.46);

    // Deer.
    int mediumDeerID=rmCreateObjectDef("medium deer");
    rmAddObjectDefItem(mediumDeerID, "deer", rmRandInt(2,8), 4.0);
    rmSetObjectDefMinDistance(mediumDeerID, 60.0);
    rmSetObjectDefMaxDistance(mediumDeerID, 80.0);
    rmAddObjectDefConstraint(mediumDeerID, avoidFood);
    rmAddObjectDefConstraint(mediumDeerID, avoidFarPlayerClass);
    for(i=1; <cNumberPlayers)
        rmPlaceObjectDefAtLoc(mediumDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
            
    rmSetStatusText("",0.49);

    // Far things.

    // Gold.
    int farGoldID=rmCreateObjectDef("far gold");
    rmAddObjectDefItem(farGoldID, "Gold mine", 1, 0.0);
    rmSetObjectDefMinDistance(farGoldID, 80.0);
    rmSetObjectDefMaxDistance(farGoldID, 150.0);
    rmAddObjectDefConstraint(farGoldID, avoidShortGold);
    rmAddObjectDefConstraint(farGoldID, avoidShortSettlement);
    rmAddObjectDefConstraint(farGoldID, avoidFarPlayerClass);
    rmPlaceObjectDefPerPlayer(farGoldID, false, rmRandInt(3, 4));

    rmSetStatusText("",0.52);

    // Bonus huntable.
    int bonusHuntableID=rmCreateObjectDef("bonus huntable");
    float bonusChance=rmRandFloat(0, 1);
    if(bonusChance < 0.33)
        rmAddObjectDefItem(bonusHuntableID, "elk", rmRandInt(3,9), 4.0);
    else if(bonusChance < 0.66)
        rmAddObjectDefItem(bonusHuntableID, "caribou", rmRandInt(3,6), 4.0);
    else
        rmAddObjectDefItem(bonusHuntableID, "aurochs", rmRandInt(3,4), 4.0);
    rmSetObjectDefMinDistance(bonusHuntableID, 0.0);
    rmSetObjectDefMaxDistance(bonusHuntableID, rmXFractionToMeters(0.5));
    rmAddObjectDefConstraint(bonusHuntableID, avoidBonusHuntable);
    rmAddObjectDefConstraint(bonusHuntableID, avoidHuntable);
    rmAddObjectDefToClass(bonusHuntableID, huntableClass);
    rmAddObjectDefConstraint(bonusHuntableID, avoidFarPlayerClass);
    rmPlaceObjectDefPerPlayer(bonusHuntableID, false, rmRandInt(1, 2));

    rmSetStatusText("",0.55);

    // Herds.
    int farCowID=rmCreateObjectDef("far Cow");
    rmAddObjectDefItem(farCowID, "cow", rmRandInt(1,2), 4.0);
    rmSetObjectDefMinDistance(farCowID, 80.0);
    rmSetObjectDefMaxDistance(farCowID, 150.0);
    rmAddObjectDefConstraint(farCowID, avoidFarPlayerClass);
    rmAddObjectDefConstraint(farCowID, avoidHerdable);
    rmAddObjectDefConstraint(farCowID, avoidFood);
    rmPlaceObjectDefPerPlayer(farCowID, false, rmRandInt(1, 2));

    rmSetStatusText("",0.61);

    // Predators - pick wolves or bears as predators
    int farPredatorID=rmCreateObjectDef("far predator");
    float predatorSpecies=rmRandFloat(0, 1);
    if(predatorSpecies<0.5)   
        rmAddObjectDefItem(farPredatorID, "wolf", rmRandInt(2,4), 4.0);
    else
        rmAddObjectDefItem(farPredatorID, "bear", 2, 4.0);
    rmSetObjectDefMinDistance(farPredatorID, 50.0);
    rmSetObjectDefMaxDistance(farPredatorID, 100.0);
    rmAddObjectDefConstraint(farPredatorID, avoidPredator);
    rmAddObjectDefConstraint(farPredatorID, avoidFarPlayerClass);
    rmAddObjectDefConstraint(farPredatorID, avoidFood);
    rmPlaceObjectDefPerPlayer(farPredatorID, false, 1);

    rmSetStatusText("",0.64);

    // Hawks
    int farhawkID=rmCreateObjectDef("far hawks");
    rmAddObjectDefItem(farhawkID, "hawk", 1, 0.0);
    rmSetObjectDefMinDistance(farhawkID, 0.0);
    rmSetObjectDefMaxDistance(farhawkID, rmXFractionToMeters(0.5));
    rmPlaceObjectDefPerPlayer(farhawkID, false, 2); 

    rmSetStatusText("",0.67);

    // Forest.
    count=0;
    numTries=20*cNumberNonGaiaPlayers;
    failCount=0;
    for(i=0; <numTries)
    {
        int forestID=rmCreateArea("forest"+i);
        rmSetAreaSize(forestID, rmAreaTilesToFraction(30), rmAreaTilesToFraction(80));
        rmSetAreaWarnFailure(forestID, false);
        rmSetAreaForestType(forestID, ForestType);
        rmAddAreaConstraint(forestID, avoidPlayerClass);
        rmAddAreaConstraint(forestID, avoidForestClass);
        rmAddAreaConstraint(forestID, avoidImpassableLand);
        rmAddAreaConstraint(forestID, avoidForestObjConstraint);
        rmAddAreaToClass(forestID, forestClass);
        rmSetAreaMinBlobs(forestID, 1);
        rmSetAreaMaxBlobs(forestID, 6);
        rmSetAreaMinBlobDistance(forestID, 12.0);
        rmSetAreaMaxBlobDistance(forestID, 36.0);
        rmSetAreaCoherence(forestID, 0.0);

        // Hill trees?
        if(rmRandFloat(0.0, 1.0)<0.2)
            rmSetAreaBaseHeight(forestID, rmRandFloat(4.0, 7.0));

        if(rmBuildArea(forestID)==false)
        {
        // Stop trying once we fail 6 times in a row.
        failCount++;
        if(failCount==6)
            break;
        }
        else
            failCount=0;
    }
    
    rmSetStatusText("",0.70);

    // Random trees
    int randomTreeID=rmCreateObjectDef("random tree");
    rmAddObjectDefItem(randomTreeID, ForestTree, 1, 0.0);
    rmSetObjectDefMinDistance(randomTreeID, 0.0);
    rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
    rmAddObjectDefConstraint(randomTreeID, avoidAllShortConstraint);
    rmAddObjectDefConstraint(randomTreeID, avoidShortSettlement);
    rmAddObjectDefConstraint(randomTreeID, avoidPlayerClass);
    rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
    rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 40*cNumberNonGaiaPlayers);

    rmSetStatusText("",0.73);

    // Relics
    for(i=0; <2)
    {
    int relicID=rmCreateObjectDef("relic"+i);
    rmAddObjectDefItem(relicID, "relic", 1, 0.0);
    rmSetObjectDefMinDistance(relicID, 50.0);
    rmSetObjectDefMaxDistance(relicID, 160.0);
    rmAddObjectDefConstraint(relicID, avoidEdgeConstraint);
    rmAddObjectDefConstraint(relicID, avoidAllShortConstraint);
    rmAddObjectDefConstraint(relicID, avoidRelic);
    rmAddObjectDefConstraint(relicID, avoidBuildings);
    rmAddObjectDefConstraint(relicID, avoidFarPlayerClass);
    rmPlaceObjectDefPerPlayer(relicID,false);
    }

    // Rocks
    int rockID=rmCreateObjectDef("rock");
    rmAddObjectDefItem(rockID, LandRocks, 1, 0.0);
    rmSetObjectDefMinDistance(rockID, 0.0);
    rmSetObjectDefMaxDistance(rockID, rmXFractionToMeters(0.5));
    rmAddObjectDefConstraint(rockID, avoidAllShortConstraint);
    rmAddObjectDefConstraint(rockID, avoidImpassableLand);
    rmAddObjectDefConstraint(rockID, avoidRock);
    rmPlaceObjectDefAtLoc(rockID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);

    // Logs
    int logID=rmCreateObjectDef("log");
    rmAddObjectDefItem(logID, "rotting log", 1, 0.0);
    rmSetObjectDefMinDistance(logID, 0.0);
    rmSetObjectDefMaxDistance(logID, rmXFractionToMeters(0.5));
    rmAddObjectDefConstraint(logID, avoidAllShortConstraint);
    rmAddObjectDefConstraint(logID, avoidImpassableLand);
    rmAddObjectDefConstraint(logID, avoidBuildings);
    rmPlaceObjectDefAtLoc(logID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);

// Triggers

     rmCreateTrigger("Intro1");
     rmCreateTrigger("SnowOn1");
     rmCreateTrigger("SnowOn2");
     rmCreateTrigger("SnowOn3");
     rmCreateTrigger("SnowOff");
     for(i=1;<=cNumberNonGaiaPlayers){
        rmCreateTrigger("DestroyIfDefeatPl"+i);
     }

     rmSwitchToTrigger(rmTriggerID("Intro1"));
     rmAddTriggerEffect("Send Chat");
     rmSetTriggerEffectParamInt("PlayerID", 0);
     rmSetTriggerEffectParam("Message","Siberian Winter  -  by M0nTy_PyTh0n");
     for(i=1;<=cNumberNonGaiaPlayers){
     rmAddTriggerEffect("Fire Event");
     rmSetTriggerEffectParamInt("EventID",rmTriggerID("DestroyIfDefeatPl"+i));
     }
     fnSetTriggerParam(4,true,true,false);

     rmSwitchToTrigger(rmTriggerID("SnowOn1"));
     rmAddTriggerCondition("Timer");
     rmSetTriggerConditionParamInt("Param1",900);
     rmAddTriggerEffect("Set Lighting");
     rmSetTriggerEffectParam("SetName","Ghost Lake");
     rmSetTriggerEffectParamInt("FadeTime",5);
     rmAddTriggerEffect("Render Snow");
     rmSetTriggerEffectParamFloat("Percent",0.1);
     rmAddTriggerEffect("Fire Event");
     rmSetTriggerEffectParamInt("EventID",rmTriggerID("SnowOn2"));
     fnSetTriggerParam(4,true,false,false);

     rmSwitchToTrigger(rmTriggerID("SnowOn2"));
     rmAddTriggerCondition("Timer");
     rmSetTriggerConditionParamInt("Param1",120);
     rmAddTriggerEffect("Sound Filename");
     rmSetTriggerEffectParam("Sound","\cinematics\29_in\wind.mp3");
     rmAddTriggerEffect("Set Lighting");
     rmSetTriggerEffectParam("SetName","Night");
     rmSetTriggerEffectParamInt("FadeTime",5);
     rmAddTriggerEffect("Render Snow");
     rmSetTriggerEffectParamFloat("Percent",1.0);
     rmAddTriggerEffect("Fire Event");
     rmSetTriggerEffectParamInt("EventID",rmTriggerID("SnowOn3"));
     fnSetTriggerParam(4,false,false,false);

     rmSwitchToTrigger(rmTriggerID("SnowOn3"));
     rmAddTriggerCondition("Timer");
     rmSetTriggerConditionParamInt("Param1",60);
     rmAddTriggerEffect("Set Lighting");
     rmSetTriggerEffectParam("SetName","Ghost Lake");
     rmSetTriggerEffectParamInt("FadeTime",5);
     rmAddTriggerEffect("Render Snow");
     rmSetTriggerEffectParamFloat("Percent",0.1);
     rmAddTriggerEffect("Fire Event");
     rmSetTriggerEffectParamInt("EventID",rmTriggerID("SnowOff"));
     fnSetTriggerParam(4,false,false,false);

     rmSwitchToTrigger(rmTriggerID("SnowOff"));
     rmAddTriggerCondition("Timer");
     rmSetTriggerConditionParamInt("Param1",120);
     rmAddTriggerEffect("Set Lighting");
     rmSetTriggerEffectParam("SetName","Olympus");
     rmSetTriggerEffectParamInt("FadeTime",5);
     rmAddTriggerEffect("Render Snow");
     rmSetTriggerEffectParamFloat("Percent",0.0);
     rmAddTriggerEffect("Fire Event");
     rmSetTriggerEffectParamInt("EventID",rmTriggerID("SnowOn1"));
     fnSetTriggerParam(4,false,false,false);

     // Create Player Defeated -> Destroy All  Triggers:
     for(i=1; <= cNumberNonGaiaPlayers){
     rmSwitchToTrigger(rmTriggerID("DestroyIfDefeatPl"+i));
     rmAddTriggerCondition("Player Defeated");
     rmSetTriggerConditionParamInt("PlayerID",i);
     rmAddTriggerEffect("Player Destroy All Buildings");
     rmSetTriggerEffectParamInt("Player",i);
     rmAddTriggerEffect("Player Destroy All Units");
     rmSetTriggerEffectParamInt("Player",i);
     rmAddTriggerEffect("Send Chat");
     rmSetTriggerEffectParamInt("PlayerID", 0);
     rmSetTriggerEffectParam("Message", "{PlayerNameString("+i+",22612)}");
     rmAddTriggerEffect("Play Dialog");
     rmSetTriggerEffectParam("Ignore","false");
     rmSetTriggerEffectParam("Sound","lightningstrike4.wav");
     fnSetTriggerParam(4,false,false,false);
     }
     
    rmSetStatusText("",1.00);
}
